using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace ConfigurationCoreTests.Configuration
{
 
    public class ItemSettings : SerializableConfigurationSection
    {
        private const string defaultItemProperty = "defaultItem";

        private const string itemsProperty = "items";

        /// <summary>
        /// <para>Initialize a new instance of the <see cref="DatabaseSettings"/> class.</para>
        /// </summary>
        public ItemSettings()
            : base()
        {
        }

        [ConfigurationProperty(itemsProperty, IsRequired = true)]
        public NameTypeConfigurationElementCollection<ItemData> Items
        {
            get
            {
                return (NameTypeConfigurationElementCollection<ItemData>)base[itemsProperty];
            }
        }

        [ConfigurationProperty(defaultItemProperty, IsRequired  = false)]
        public string DefaultItem
        {
            get
            {
                return (string)this[defaultItemProperty];
            }
            set
            {
                this[defaultItemProperty] = value;
            }
        }
    }
}
