using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.ObjectBuilder;
using ConfigurationCoreTests;   
namespace ConfigurationCoreTests.Configuration
{
    [Assembler(typeof(SoftwareItemAssembler))]
    class SoftwareItemData:ItemData 
    {
        private const string versionProperty = "version";
        public SoftwareItemData()
        {
        }
        public SoftwareItemData(string name,Type type,decimal price,int quantity,string version):base(name,type,price,quantity)   
        {
            this.Version = version; 
        }

        [ConfigurationProperty(versionProperty, IsRequired = true)]
        public string Version
        {
            get { return (string)base[versionProperty]; }
            set { base[versionProperty] = value; }
        }
    }

    class SoftwareItemAssembler : IAssembler<IItem, ItemData>
    {
        public IItem Assemble(IBuilderContext context, ItemData objectConfiguration, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            SoftwareItemData itemdata = (SoftwareItemData)objectConfiguration;
            IItem createdObject = new SoftwareItem(itemdata.Price, itemdata.Quantity, itemdata.Version);
            return createdObject;
        }

    }
}
