using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Instrumentation;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;     
using ConfigurationCoreTests.Configuration; 

namespace ConfigurationCoreTests
{
    [CustomFactory(typeof(CarManagerCustomFactory))]
    public class Car
    {
        string model;
        string brand;
        CarPartsData carParts;
        int speed = 30;

        public int Speed
        {
            get { return speed; }
            set { speed = value;}
        }

        public string Wheel
        {
            get { return carParts.WheelType ; }
            set { carParts.WheelType  = value; }
        }

        public Car(CarPartsData parts, string model, string brand)
        {
            carParts = parts;
            this.model = model;
            this.brand = brand;
        }

        public void IncreaseSpeed()
        {
            speed += 10;
        }

        public void DecreaseSpeed()
        {
            speed -= 10;
        }

        public void ChangeWheel()
        {
            if (carParts.WheelType.Equals("Alloy"))
            {
                carParts.WheelType = "Steel";
            }
            else
            {
                carParts.WheelType = "Alloy"; 
            }
        }
    }
}
