using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Instrumentation;
namespace ConfigurationCoreTests
{
    [InstrumentationListener(typeof(ItemInstrumentationListener))]  
    public class ItemInstrumentationProvider
    {
        [InstrumentationProvider("ItemCalculated")]
        public event EventHandler<EventArgs> itemCalculated;

        [InstrumentationProvider("CalculationError")]
        public event EventHandler<ErrorEventArgs> errorCalculating;

        public void FireItemCalculatedEvent()
        {
            if (itemCalculated  != null) itemCalculated (this, new EventArgs());
        }

        public void FireErrorCalculating(Exception e)
        {
            if (errorCalculating != null) errorCalculating (this, new ErrorEventArgs(e.Message,e.StackTrace));
        }

    }
}
