using System;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using System.Threading;
using System.Collections.Generic;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using System.Data.SqlClient;
using System.IO;
using System.Diagnostics;

namespace ExceptionHandlingCoreTests
{
    /// <summary>
    /// Summary description for ExceptionThreadingDictSourceTestFixture
    /// </summary>
    [TestClass]
    public class ExceptionThreadingDictSourceTestFixture
    {
        bool threadComplete;
        int count = 0;
        private DictionaryConfigurationSource configSource;
        private ExceptionPolicyFactory factory;

        public ExceptionThreadingDictSourceTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        /// Initialize() is called once during test execution before
        /// test methods in this test class are executed.
        /// </summary>
        [TestInitialize()]
        public void Initialize()
        {
            //  TODO: Add test initialization code
            DictionarySourceSection sourceSection = new DictionarySourceSection();
            configSource = sourceSection.BuildDictionarySourceSection();
            factory = new ExceptionPolicyFactory(configSource);    
        }

        /// <summary>
        /// Cleanup() is called once during test execution after
        /// test methods in this class have executed unless the
        /// corresponding Initialize() call threw an exception.
        /// </summary>
        [TestCleanup()]
        public void Cleanup()
        {
            //  TODO: Add test cleanup code
        }

        [TestMethod]
        public void MutipleThreadDictSourceTestFixture()
        {
            Thread[] exThread = new Thread[100];
            for (int i = 0; i < 100; i++)
            {
                exThread[i] = new Thread(new ThreadStart(RaiseException));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            int timeoutCount = 100;
            int index = 0;
            bool loopTimed = false;
            while (!threadComplete || (loopTimed == false))
            {

                Thread.Sleep(100);
                index++;
                if (index == timeoutCount)
                {
                    loopTimed = true;
                }
            }
            Assert.AreEqual(true, threadComplete);
            Assert.AreEqual(100, count);
        }

        public void RaiseException()
        {
            Exception originalException = new System.Security.SecurityException("Original Exception: Security Exception");
            bool rethrow = false;

            ExceptionPolicyImpl epi = factory.Create("Replace with None Dic");
            rethrow = epi.HandleException(originalException);

            threadComplete = true;
            count++;

        }
    }
}
