using System;
using System.Text;
using System.Collections.Generic;
using System.Configuration;
using System.Security.Principal;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Security.AzMan;



namespace SecurityAzManFuncTests
{
    /// <summary>
    /// Summary description for AzManObjectCreationTestFixture
    /// </summary>
    [TestClass]
    public class AzManObjectCreationTestFixture
    {
        public AzManObjectCreationTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void CreateNamedAzmanInConfigFile()
        {
            IAuthorizationProvider azManProvider = AuthorizationFactory.GetAuthorizationProvider("DefaultAzManProvider");
            Assert.IsNotNull(azManProvider);
        }
        [TestMethod]
        public void CreateDefaultAzmanFromConfigFile()
        {
            IAuthorizationProvider azManProvider = AuthorizationFactory.GetAuthorizationProvider();
            Assert.IsNotNull(azManProvider);

        }

        [TestMethod]
        [ExpectedException(typeof(ConfigurationErrorsException))]
        public void CreateInvalidAzmanFromConfigFile()
        {
            IAuthorizationProvider azManProvider = AuthorizationFactory.GetAuthorizationProvider("InvalidProvider");
        }

        [TestMethod]
        public void CreateAzManDirectRelativePathStoreLocation()
        {
            IAuthorizationProvider azManProvider = new AzManAuthorizationProvider(@"msxml://{currentPath}/AzManFuncTestsConfig.xml", "SecurityAzManFuncTests", "", "");
            WindowsPrincipal principal = new WindowsPrincipal(WindowsIdentity.GetCurrent());
            azManProvider.Authorize(principal,"Authorize Purchase");
        }
    
    }
}
